SystemOrganization addCategory: #'TP Integrador'!

Object subclass: #Condicion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

Condicion subclass: #Dormido
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Dormido methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 20:46'!
tePodesMover 
^Moneda flip ifTrue:[^true and self condicion:Normal]
ifFalse:[^false]. ! !

Condicion subclass: #Normal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Normal methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 20:20'!
tePodesMover
^true.! !

Condicion subclass: #Paralizado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Paralizado methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 20:49'!
tePodesMover 
Moneda flip ifTrue:[^true]
ifFalse:[^false].! !

Object subclass: #Movimiento
	instanceVariableNames: 'usosDisponibles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Movimiento methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:11'!
estasDisponible
^usosDisponibles >0.! !

!Movimiento methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:14'!
unUsoMenos 
usosDisponibles:=usosDisponibles -1.! !

Movimiento subclass: #MovimientoCurativo
	instanceVariableNames: 'puntosDeVida puntosACurar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!MovimientoCurativo methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:49'!
aplicarEfectoA: otroPokemon
self curate:puntosACurar.! !

!MovimientoCurativo methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:44'!
puntosACurar:unaCantidad
puntosACurar:=unaCantidad.! !

Movimiento subclass: #MovimientoDanino
	instanceVariableNames: 'puntosDeDao'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:46'!
aplicarEfectoA:otroPokemon
otroPokemon teDaaron:puntosDeDao.! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:47'!
puntosDeDao:unaCantidad
puntosDeDao:=unaCantidad. ! !

Movimiento subclass: #MovimientoEspecial
	instanceVariableNames: 'condicionAAplicar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!MovimientoEspecial methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:55'!
aplicarEfectoA: otroPokemon
otroPokemon teCondicionanCon: condicionAAplicar.! !

!MovimientoEspecial methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:55'!
condicionAAplicar:unaCondicion
condicionAAplicar:=unaCondicion. ! !

Object subclass: #Objeto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

Objeto subclass: #Medicina
	instanceVariableNames: 'cantidadQueCura'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Medicina methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:34'!
aplicarEn:unPokemon
unPokemon curate:cantidadQueCura.! !

!Medicina methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:34'!
cantidadQueCura:unaCantidad
cantidadQueCura:=unaCantidad. ! !

Objeto subclass: #MedicinaEspecial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!MedicinaEspecial methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:35'!
aplicarEn:unPokemon
unPokemon condicion:Normal.! !

Objeto subclass: #Pokebola
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Pokebola methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:40'!
aplicarEn:unPokemon
! !

Object subclass: #Pokemon
	instanceVariableNames: 'movimientos puntosDeVida condicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 20:50'!
condicion
^condicion.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:57'!
condicion:unaCondicion
condicion:=unaCondicion. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:01'!
curate:unosPuntos
puntosDeVida:=puntosDeVida + (unosPuntos).! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 20:51'!
initialize
movimientos:=Set new. 
self condicion:Normal.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:07'!
luchaCon:unMovimiento contra:otroPokemon
self condicion tePodesMover. "Aca habra que tirar un error si no se puede mover, probablemente no con self error, sino con una signal, como vimos en alguna de las ultimas clases, pero todava no lo se hacer bien eso."
self movimiento:unMovimiento contra:otroPokemon.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:13'!
movimiento:unMovimiento contra:otroPokemon
unMovimiento aplicarEfectoA:otroPokemon.
unMovimiento unUsoMenos. 
! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 18:26'!
movimientosDisponibles
movimientos select:[:movimiento|movimiento estasDisponible]. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/21/2013 20:57'!
teCogesAMisty
	! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:56'!
teCondicionanCon: unaCondicion
self condicion:unaCondicion.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:02'!
teDaaron:unosPuntos
puntosDeVida:=(puntosDeVida-unosPuntos max:0) . ! !
